<html>
<head>
<title>OgreMemorySTLAllocator.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreMemorySTLAllocator.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreMemorySTLAllocator_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="preprocessor">#ifndef _MemorySTLAllocator_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#define _MemorySTLAllocator_H__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreHeaderPrefix_8h.html">OgreHeaderPrefix.h</a>&quot;</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="keyword">namespace </span>Ogre
<a name="l00036"></a>00036 {
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 
<a name="l00062"></a>00062     <span class="comment">// Base STL allocator class.</span>
<a name="l00063"></a>00063     <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00064"></a><a class="code" href="structOgre_1_1STLAllocatorBase.html">00064</a>     <span class="keyword">struct </span><a class="code" href="structOgre_1_1STLAllocatorBase.html" title="Wrapper class for operating as an STL container allocator.">STLAllocatorBase</a>
<a name="l00065"></a>00065     {   <span class="comment">// base class for generic allocators</span>
<a name="l00066"></a><a class="code" href="structOgre_1_1STLAllocatorBase.html#a3fc45e6ad404fa54ad9246682e7ccd88">00066</a>         <span class="keyword">typedef</span> T <a class="code" href="structOgre_1_1STLAllocatorBase.html#a3fc45e6ad404fa54ad9246682e7ccd88">value_type</a>;
<a name="l00067"></a>00067     };
<a name="l00068"></a>00068 
<a name="l00069"></a>00069     <span class="comment">// Base STL allocator class. (const T version).</span>
<a name="l00070"></a>00070     <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00071"></a><a class="code" href="structOgre_1_1STLAllocatorBase_3_01const_01T_01_4.html">00071</a>     <span class="keyword">struct </span><a class="code" href="structOgre_1_1STLAllocatorBase.html" title="Wrapper class for operating as an STL container allocator.">STLAllocatorBase</a>&lt;const T&gt;
<a name="l00072"></a>00072     {   <span class="comment">// base class for generic allocators for const T</span>
<a name="l00073"></a><a class="code" href="structOgre_1_1STLAllocatorBase_3_01const_01T_01_4.html#ad0004d963c1616f06b527bc144bd883f">00073</a>         <span class="keyword">typedef</span> T <a class="code" href="structOgre_1_1STLAllocatorBase_3_01const_01T_01_4.html#ad0004d963c1616f06b527bc144bd883f">value_type</a>;
<a name="l00074"></a>00074     };
<a name="l00075"></a>00075 
<a name="l00076"></a>00076     <span class="keyword">template</span>
<a name="l00077"></a>00077         &lt;
<a name="l00078"></a>00078         <span class="keyword">typename</span> T,
<a name="l00079"></a>00079         <span class="keyword">typename</span> AllocPolicy
<a name="l00080"></a>00080         &gt;
<a name="l00081"></a><a class="code" href="classOgre_1_1STLAllocator.html">00081</a>     <span class="keyword">class </span><a class="code" href="classOgre_1_1STLAllocator.html">STLAllocator</a> : <span class="keyword">public</span> <a class="code" href="structOgre_1_1STLAllocatorBase.html" title="Wrapper class for operating as an STL container allocator.">STLAllocatorBase</a>&lt;T&gt;
<a name="l00082"></a>00082     {
<a name="l00083"></a>00083     <span class="keyword">public</span> :
<a name="l00085"></a><a class="code" href="classOgre_1_1STLAllocator.html#a31bf54b866ab68cdf4065adb9eee9a93">00085</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1STLAllocatorBase.html" title="Wrapper class for operating as an STL container allocator.">STLAllocatorBase&lt;T&gt;</a>         <a class="code" href="classOgre_1_1STLAllocator.html#a31bf54b866ab68cdf4065adb9eee9a93" title="define our types, as per ISO C++">Base</a>;
<a name="l00086"></a><a class="code" href="classOgre_1_1STLAllocator.html#af5221070699c31f29ff62f889ffd9b32">00086</a>         <span class="keyword">typedef</span> <span class="keyword">typename</span> <a class="code" href="structOgre_1_1STLAllocatorBase.html#a3fc45e6ad404fa54ad9246682e7ccd88">Base::value_type</a>   <a class="code" href="classOgre_1_1STLAllocator.html#af5221070699c31f29ff62f889ffd9b32">value_type</a>;
<a name="l00087"></a><a class="code" href="classOgre_1_1STLAllocator.html#af0eca020577a396b472cf5c2c3ae2a58">00087</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1STLAllocatorBase.html#a3fc45e6ad404fa54ad9246682e7ccd88">value_type</a>*                 <a class="code" href="classOgre_1_1STLAllocator.html#af0eca020577a396b472cf5c2c3ae2a58">pointer</a>;
<a name="l00088"></a><a class="code" href="classOgre_1_1STLAllocator.html#a26b77b3bc8f9fff5a33acc22f55ec3df">00088</a>         <span class="keyword">typedef</span> <span class="keyword">const</span> <a class="code" href="structOgre_1_1STLAllocatorBase.html#a3fc45e6ad404fa54ad9246682e7ccd88">value_type</a>*           <a class="code" href="classOgre_1_1STLAllocator.html#a26b77b3bc8f9fff5a33acc22f55ec3df">const_pointer</a>;
<a name="l00089"></a><a class="code" href="classOgre_1_1STLAllocator.html#a5d26e2252c837f0620a51c075aeb6d56">00089</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1STLAllocatorBase.html#a3fc45e6ad404fa54ad9246682e7ccd88">value_type</a>&amp;                 <a class="code" href="classOgre_1_1STLAllocator.html#a5d26e2252c837f0620a51c075aeb6d56">reference</a>;
<a name="l00090"></a><a class="code" href="classOgre_1_1STLAllocator.html#ab1503596eb95026cd4a65164f612a407">00090</a>         <span class="keyword">typedef</span> <span class="keyword">const</span> <a class="code" href="structOgre_1_1STLAllocatorBase.html#a3fc45e6ad404fa54ad9246682e7ccd88">value_type</a>&amp;           <a class="code" href="classOgre_1_1STLAllocator.html#ab1503596eb95026cd4a65164f612a407">const_reference</a>;
<a name="l00091"></a><a class="code" href="classOgre_1_1STLAllocator.html#aabd94312eb1a0e3f84339e5d810c273f">00091</a>         <span class="keyword">typedef</span> std::size_t                 <a class="code" href="classOgre_1_1STLAllocator.html#aabd94312eb1a0e3f84339e5d810c273f">size_type</a>;
<a name="l00092"></a><a class="code" href="classOgre_1_1STLAllocator.html#af82f6b541d4c320854df346e04ab62ce">00092</a>         <span class="keyword">typedef</span> std::ptrdiff_t              <a class="code" href="classOgre_1_1STLAllocator.html#af82f6b541d4c320854df346e04ab62ce">difference_type</a>;
<a name="l00093"></a>00093 
<a name="l00094"></a>00094 
<a name="l00096"></a>00096         <span class="keyword">template</span>&lt;<span class="keyword">typename</span> U&gt;
<a name="l00097"></a><a class="code" href="structOgre_1_1STLAllocator_1_1rebind.html">00097</a>         <span class="keyword">struct </span><a class="code" href="structOgre_1_1STLAllocator_1_1rebind.html" title="the standard rebind mechanism">rebind</a>
<a name="l00098"></a>00098         {
<a name="l00099"></a><a class="code" href="structOgre_1_1STLAllocator_1_1rebind.html#a38ae5b67425ece5706373301c23915f0">00099</a>             <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1STLAllocator.html">STLAllocator&lt;U, AllocPolicy&gt;</a> <a class="code" href="structOgre_1_1STLAllocator_1_1rebind.html#a38ae5b67425ece5706373301c23915f0">other</a>;
<a name="l00100"></a>00100         };
<a name="l00101"></a>00101 
<a name="l00103"></a><a class="code" href="classOgre_1_1STLAllocator.html#a9c25559c7ed0e526a0195d4d44efce10">00103</a>         <span class="keyword">inline</span> <span class="keyword">explicit</span> <a class="code" href="classOgre_1_1STLAllocator.html#a9c25559c7ed0e526a0195d4d44efce10" title="ctor">STLAllocator</a>()
<a name="l00104"></a>00104         { }
<a name="l00105"></a>00105 
<a name="l00107"></a><a class="code" href="classOgre_1_1STLAllocator.html#ab4be8634d905e1c62cfbaeca27389188">00107</a>         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1STLAllocator.html#ab4be8634d905e1c62cfbaeca27389188" title="dtor">~STLAllocator</a>()
<a name="l00108"></a>00108         { }
<a name="l00109"></a>00109 
<a name="l00111"></a><a class="code" href="classOgre_1_1STLAllocator.html#af85d3e2726cef7ec1f1d24f2ed3b0675">00111</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1STLAllocator.html#a9c25559c7ed0e526a0195d4d44efce10" title="ctor">STLAllocator</a>( <a class="code" href="classOgre_1_1STLAllocator.html">STLAllocator</a> <span class="keyword">const</span>&amp; )
<a name="l00112"></a>00112         { }
<a name="l00113"></a>00113 
<a name="l00115"></a>00115         <span class="keyword">template</span> &lt;<span class="keyword">typename</span> U&gt;
<a name="l00116"></a><a class="code" href="classOgre_1_1STLAllocator.html#a3d97ea3f530a55614990908f19ccd533">00116</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1STLAllocator.html#a9c25559c7ed0e526a0195d4d44efce10" title="ctor">STLAllocator</a>( <a class="code" href="classOgre_1_1STLAllocator.html">STLAllocator&lt;U, AllocPolicy&gt;</a> <span class="keyword">const</span>&amp; )
<a name="l00117"></a>00117         { }
<a name="l00118"></a>00118 
<a name="l00120"></a>00120         <span class="keyword">template</span> &lt;<span class="keyword">typename</span> U, <span class="keyword">typename</span> P&gt;
<a name="l00121"></a><a class="code" href="classOgre_1_1STLAllocator.html#ac80a6c2569f5812937287072c04d23ea">00121</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1STLAllocator.html#a9c25559c7ed0e526a0195d4d44efce10" title="ctor">STLAllocator</a>( <a class="code" href="classOgre_1_1STLAllocator.html">STLAllocator&lt;U, P&gt;</a> <span class="keyword">const</span>&amp; )
<a name="l00122"></a>00122         { }
<a name="l00123"></a>00123 
<a name="l00125"></a><a class="code" href="classOgre_1_1STLAllocator.html#a219db3b3227be55452bf297cdb7bea89">00125</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1STLAllocator.html#af0eca020577a396b472cf5c2c3ae2a58">pointer</a> <a class="code" href="classOgre_1_1STLAllocator.html#a219db3b3227be55452bf297cdb7bea89" title="memory allocation (elements, used by STL)">allocate</a>( <a class="code" href="classOgre_1_1STLAllocator.html#aabd94312eb1a0e3f84339e5d810c273f">size_type</a> count,
<a name="l00126"></a>00126             <span class="keyword">typename</span> std::allocator&lt;void&gt;::const_pointer ptr = 0 )
<a name="l00127"></a>00127         {
<a name="l00128"></a>00128                         (void)ptr;
<a name="l00129"></a>00129             <span class="comment">// convert request to bytes</span>
<a name="l00130"></a>00130             <span class="keyword">register</span> <a class="code" href="classOgre_1_1STLAllocator.html#aabd94312eb1a0e3f84339e5d810c273f">size_type</a> sz = count*<span class="keyword">sizeof</span>( T );
<a name="l00131"></a>00131             <a class="code" href="classOgre_1_1STLAllocator.html#af0eca020577a396b472cf5c2c3ae2a58">pointer</a> p  = <span class="keyword">static_cast&lt;</span><a class="code" href="classOgre_1_1STLAllocator.html#af0eca020577a396b472cf5c2c3ae2a58">pointer</a><span class="keyword">&gt;</span>(AllocPolicy::allocateBytes(sz));
<a name="l00132"></a>00132             <span class="keywordflow">return</span> p;
<a name="l00133"></a>00133         }
<a name="l00134"></a>00134 
<a name="l00136"></a><a class="code" href="classOgre_1_1STLAllocator.html#afc5b83dfdc2263f0c6dbebe62c4681a9">00136</a>         <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1STLAllocator.html#afc5b83dfdc2263f0c6dbebe62c4681a9" title="memory deallocation (elements, used by STL)">deallocate</a>( <a class="code" href="classOgre_1_1STLAllocator.html#af0eca020577a396b472cf5c2c3ae2a58">pointer</a> ptr, <a class="code" href="classOgre_1_1STLAllocator.html#aabd94312eb1a0e3f84339e5d810c273f">size_type</a> )
<a name="l00137"></a>00137         {
<a name="l00138"></a>00138             <span class="comment">// convert request to bytes, but we can&#39;t use this?</span>
<a name="l00139"></a>00139             <span class="comment">// register size_type sz = count*sizeof( T );</span>
<a name="l00140"></a>00140             AllocPolicy::deallocateBytes(ptr);
<a name="l00141"></a>00141         }
<a name="l00142"></a>00142 
<a name="l00143"></a><a class="code" href="classOgre_1_1STLAllocator.html#ad85c5a0fc7665135ab6965b1a6578a0b">00143</a>         <a class="code" href="classOgre_1_1STLAllocator.html#af0eca020577a396b472cf5c2c3ae2a58">pointer</a> <a class="code" href="classOgre_1_1STLAllocator.html#ad85c5a0fc7665135ab6965b1a6578a0b">address</a>(<a class="code" href="classOgre_1_1STLAllocator.html#a5d26e2252c837f0620a51c075aeb6d56">reference</a> x)<span class="keyword"> const</span>
<a name="l00144"></a>00144 <span class="keyword">        </span>{
<a name="l00145"></a>00145             <span class="keywordflow">return</span> &amp;x;
<a name="l00146"></a>00146         }
<a name="l00147"></a>00147 
<a name="l00148"></a><a class="code" href="classOgre_1_1STLAllocator.html#ab0c9ec3f0b3d15832db68093828df934">00148</a>         <a class="code" href="classOgre_1_1STLAllocator.html#a26b77b3bc8f9fff5a33acc22f55ec3df">const_pointer</a> <a class="code" href="classOgre_1_1STLAllocator.html#ad85c5a0fc7665135ab6965b1a6578a0b">address</a>(<a class="code" href="classOgre_1_1STLAllocator.html#ab1503596eb95026cd4a65164f612a407">const_reference</a> x)<span class="keyword"> const</span>
<a name="l00149"></a>00149 <span class="keyword">        </span>{
<a name="l00150"></a>00150             <span class="keywordflow">return</span> &amp;x;
<a name="l00151"></a>00151         }
<a name="l00152"></a>00152 
<a name="l00153"></a><a class="code" href="classOgre_1_1STLAllocator.html#a34af39aff69a8cb62b7548df92fa8aad">00153</a>         <a class="code" href="classOgre_1_1STLAllocator.html#aabd94312eb1a0e3f84339e5d810c273f">size_type</a> <a class="code" href="classOgre_1_1STLAllocator.html#a34af39aff69a8cb62b7548df92fa8aad">max_size</a>() <span class="keyword">const</span> throw()
<a name="l00154"></a>00154         {
<a name="l00155"></a>00155             <span class="comment">// maximum size this can handle, delegate</span>
<a name="l00156"></a>00156             <span class="keywordflow">return</span> AllocPolicy::getMaxAllocationSize();
<a name="l00157"></a>00157         }
<a name="l00158"></a>00158 
<a name="l00159"></a><a class="code" href="classOgre_1_1STLAllocator.html#a04d59556081dfe8d64d660b336b6fc28">00159</a>         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1STLAllocator.html#a04d59556081dfe8d64d660b336b6fc28">construct</a>(<a class="code" href="classOgre_1_1STLAllocator.html#af0eca020577a396b472cf5c2c3ae2a58">pointer</a> p)
<a name="l00160"></a>00160         {
<a name="l00161"></a>00161             <span class="comment">// call placement new</span>
<a name="l00162"></a>00162             <span class="keyword">new</span>(<span class="keyword">static_cast&lt;</span><span class="keywordtype">void</span>*<span class="keyword">&gt;</span>(p)) T();
<a name="l00163"></a>00163         }
<a name="l00164"></a>00164 
<a name="l00165"></a><a class="code" href="classOgre_1_1STLAllocator.html#ad6ebf2ce6e910595ef613fc955e6df10">00165</a>         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1STLAllocator.html#a04d59556081dfe8d64d660b336b6fc28">construct</a>(<a class="code" href="classOgre_1_1STLAllocator.html#af0eca020577a396b472cf5c2c3ae2a58">pointer</a> p, <span class="keyword">const</span> T&amp; val)
<a name="l00166"></a>00166         {
<a name="l00167"></a>00167             <span class="comment">// call placement new</span>
<a name="l00168"></a>00168             <span class="keyword">new</span>(<span class="keyword">static_cast&lt;</span><span class="keywordtype">void</span>*<span class="keyword">&gt;</span>(p)) T(val);
<a name="l00169"></a>00169         }
<a name="l00170"></a>00170 
<a name="l00171"></a><a class="code" href="classOgre_1_1STLAllocator.html#ad4101ccdcdc6c5336a2ebd5169c55ff9">00171</a>         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1STLAllocator.html#ad4101ccdcdc6c5336a2ebd5169c55ff9">destroy</a>(<a class="code" href="classOgre_1_1STLAllocator.html#af0eca020577a396b472cf5c2c3ae2a58">pointer</a> p)
<a name="l00172"></a>00172         {
<a name="l00173"></a>00173             <span class="comment">// do we have to protect against non-classes here?</span>
<a name="l00174"></a>00174             <span class="comment">// some articles suggest yes, some no</span>
<a name="l00175"></a>00175             p-&gt;~T();
<a name="l00176"></a>00176         }
<a name="l00177"></a>00177 
<a name="l00178"></a>00178     };
<a name="l00179"></a>00179 
<a name="l00182"></a>00182     <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T, <span class="keyword">typename</span> T2, <span class="keyword">typename</span> P&gt;
<a name="l00183"></a><a class="code" href="group__Memory.html#gaa5b83b2ba3ce965e3d8dd129c93ee43b">00183</a>     <span class="keyword">inline</span> <span class="keywordtype">bool</span> <a class="code" href="group__Memory.html#gaa5b83b2ba3ce965e3d8dd129c93ee43b" title="determine equality, can memory from another allocator be released by this allocator, (ISO C++)">operator==</a>(<a class="code" href="classOgre_1_1STLAllocator.html">STLAllocator&lt;T,P&gt;</a> <span class="keyword">const</span>&amp;,
<a name="l00184"></a>00184         <a class="code" href="classOgre_1_1STLAllocator.html">STLAllocator&lt;T2,P&gt;</a> <span class="keyword">const</span>&amp;)
<a name="l00185"></a>00185     {
<a name="l00186"></a>00186         <span class="comment">// same alloc policy (P), memory can be freed</span>
<a name="l00187"></a>00187         <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00188"></a>00188     }
<a name="l00189"></a>00189 
<a name="l00192"></a>00192     <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T, <span class="keyword">typename</span> P, <span class="keyword">typename</span> OtherAllocator&gt;
<a name="l00193"></a><a class="code" href="group__Memory.html#gaa34a630f2287087875d360c454a0fb48">00193</a>     <span class="keyword">inline</span> <span class="keywordtype">bool</span> <a class="code" href="group__Memory.html#gaa5b83b2ba3ce965e3d8dd129c93ee43b" title="determine equality, can memory from another allocator be released by this allocator, (ISO C++)">operator==</a>(<a class="code" href="classOgre_1_1STLAllocator.html">STLAllocator&lt;T,P&gt;</a> <span class="keyword">const</span>&amp;,
<a name="l00194"></a>00194         OtherAllocator <span class="keyword">const</span>&amp;)
<a name="l00195"></a>00195     {
<a name="l00196"></a>00196         <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00197"></a>00197     }
<a name="l00200"></a>00200     <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T, <span class="keyword">typename</span> T2, <span class="keyword">typename</span> P&gt;
<a name="l00201"></a><a class="code" href="group__Memory.html#ga34a9308dc656f694883718bf8fa4f1c2">00201</a>     <span class="keyword">inline</span> <span class="keywordtype">bool</span> <a class="code" href="group__Memory.html#ga34a9308dc656f694883718bf8fa4f1c2" title="determine equality, can memory from another allocator be released by this allocator, (ISO C++)">operator!=</a>(<a class="code" href="classOgre_1_1STLAllocator.html">STLAllocator&lt;T,P&gt;</a> <span class="keyword">const</span>&amp;,
<a name="l00202"></a>00202         <a class="code" href="classOgre_1_1STLAllocator.html">STLAllocator&lt;T2,P&gt;</a> <span class="keyword">const</span>&amp;)
<a name="l00203"></a>00203     {
<a name="l00204"></a>00204         <span class="comment">// same alloc policy (P), memory can be freed</span>
<a name="l00205"></a>00205         <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00206"></a>00206     }
<a name="l00207"></a>00207 
<a name="l00210"></a>00210     <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T, <span class="keyword">typename</span> P, <span class="keyword">typename</span> OtherAllocator&gt;
<a name="l00211"></a><a class="code" href="group__Memory.html#ga0cec9339a4ab3eaf48c767087cd7f400">00211</a>     <span class="keyword">inline</span> <span class="keywordtype">bool</span> <a class="code" href="group__Memory.html#ga34a9308dc656f694883718bf8fa4f1c2" title="determine equality, can memory from another allocator be released by this allocator, (ISO C++)">operator!=</a>(<a class="code" href="classOgre_1_1STLAllocator.html">STLAllocator&lt;T,P&gt;</a> <span class="keyword">const</span>&amp;,
<a name="l00212"></a>00212         OtherAllocator <span class="keyword">const</span>&amp;)
<a name="l00213"></a>00213     {
<a name="l00214"></a>00214         <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00215"></a>00215     }
<a name="l00216"></a>00216 
<a name="l00217"></a>00217 
<a name="l00221"></a>00221 }<span class="comment">// namespace Ogre</span>
<a name="l00222"></a>00222 
<a name="l00223"></a>00223 <span class="preprocessor">#include &quot;<a class="code" href="OgreHeaderSuffix_8h.html">OgreHeaderSuffix.h</a>&quot;</span>
<a name="l00224"></a>00224 <span class="preprocessor">#endif // _MemorySTLAllocator_H__</span>
<a name="l00225"></a>00225 <span class="preprocessor"></span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:50
</p>
</body>
</html>
